unit hns_rea1;
{By han_kleijn@hnsky.org. (c) 2001, 2002, 2003, 2014 for non-commercial use only }

{See also restrictions using getdss.dll in readme.doc file of project pluto}
{For updates have a look to www.hnsky.org}

{When compiling with Delphi 4, the disabling prompt_CD does not work. So use Delphi 6}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DdeMan, Menus, ComCtrls;
var
  settingstring :tstrings; {settings for save and loading}
type
  Tmainwindow = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Button1: TButton;
    Label10: TLabel;
    background: TScrollBar;
    brightness: TScrollBar;
    Label12: TLabel;
    Label13: TLabel;
    DdeClientConv1: TDdeClientConv;
    DdeClientItem1: TDdeClientItem;
    Labelserver: TLabel;
    MainMenu1: TMainMenu;
    Help: TMenuItem;
    Savesetting1: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    File1: TMenuItem;
    DdeClientItem2: TDdeClientItem;
    AboutDSS1: TMenuItem;
    AboutDDEcontrol1: TMenuItem;
    OpenDialog1: TOpenDialog;
    LoadFITSfile1: TMenuItem;
    N1: TMenuItem;
    SaveasBMP1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    ShowFITSheader1: TMenuItem;
    north_arrow: TCheckBox;
    mouse_pos: TDdeServerItem;
    target: TDdeServerItem;
    output: TDdeServerConv;
    showpicture: TCheckBox;
    dsspolynom: TCheckBox;
    Saveas8bitFITS1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Aboutplatesolution1: TMenuItem;
    Extratool1: TMenuItem;
    Convertallfiles8bitFITS1: TMenuItem;
    combobox1: TComboBox;
    prompt_CD: TCheckBox;
    ConvertallFITStoBMP1: TMenuItem;
    N4: TMenuItem;
    Saveas8bitFITSfileadjusted: TMenuItem;
    auto_adjust: TCheckBox;
    error_get_it: TLabel;
    source_selection: TComboBox;
    Labelclient: TLabel;
    ConvertselectedFITSfilesto8bitFITSUsingdatamindatamaxfromFITSheader1: TMenuItem;
    use_datamin: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure DdeClientConv1Open(Sender: TObject);
    procedure DdeClientConv1Close(Sender: TObject);
    procedure DdeClientItem1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Savesetting1Click(Sender: TObject);
    procedure AboutDSS1Click(Sender: TObject);
    procedure AboutDDEcontrol1Click(Sender: TObject);
    procedure LoadFITSfile1Click(Sender: TObject);
    procedure SaveasBMP1Click(Sender: TObject);
    procedure ShowFITSheader1Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure targetPokeData(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Saveas8bitFITS1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Aboutplatesolution1Click(Sender: TObject);
    procedure Convertallfiles8bitFITS1_datamindatamaxClick(Sender: TObject);
    procedure ConvertallFITStoBMP1Click(Sender: TObject);
    procedure Saveas8bitFITSfileadjustedClick(Sender: TObject);
    procedure outputClose(Sender: TObject);
    procedure outputOpen(Sender: TObject);
    procedure Convertallfiles8bitFITS1_usingsettingsClick(Sender: TObject);
    procedure backgroundScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mainwindow: Tmainwindow;
  filename2  : string;
  currdir   : string; 
  makebit8   : boolean; {make an additional 8 bit fits?}
const
   initialized:boolean=false;
   adjustbrightness:boolean=false;
implementation

uses hns_rea2;

{$R *.DFM}
  type SImageConfig = record
     pDir : Pchar;
     pDrive : Pchar;
     pImageFile : Pchar;
     DataSource : integer;
     PromptForDisk : boolean;
     SubSample : integer;
     Ra : double;
     De : double;
     Width : double;
     Height : double;
     Sender : Thandle;
     pApplication :Pchar;
     pPrompt1 : Pchar;
     pPrompt2 : Pchar;
  end;
  type Plate_data = record
   nplate : integer;
   plate_name, gsc_plate_name : array[1..10]of Pchar;
   dist_from_edge, cd_number, is_uk_survey : array[1..10]of integer;
   year_imaged, exposure : array[1..10]of double;
  end;
  PImageConfig = ^SImageConfig;
  PPlate_data = ^Plate_data;

type TImageExtract=function( img : PImageConfig): Integer; cdecl;
     TGetPlateList=function( img : PImageConfig; pl : PPlate_data): Integer;cdecl;
     TImageExtractFromPlate=function( img : PImageConfig; ReqPlateName : Pchar): Integer;cdecl;
var  ImageExtract: TImageExtract;
     GetPlateList: TGetPlateList;
     ImageExtractFromPlate: TImageExtractFromPlate;
     dsslib : integer;

const
   sizechanged:boolean=true;
   left2 : integer=30;{screen position}
   top2  : integer=30;{screen position}

procedure Tmainwindow.About1Click(Sender: TObject);
begin
  messagebox(mainwindow.handle,
          'HNS_REAL, Realsky r or Digitial Sky Survey r image viewer:'+
  #10+#13+
  #10+#13+'This is a stand-alone DSS or Realsky viewer which can be DDE controlled from the HNSKY program. '+
          'The mouse position is indicated by either the WCS header or the DSS proper astrometric plate solution. '+
          'Centering is achieved by the right mouse button. The left mouse button will send the mouse position to HNSKY using DDE. '+
  #10+#13+
  #10+#13+'To get the DDE control activated:'+
  #10+#13+
  #10+#13+'   1) Put HNSKY and HNS_REAL in same directory.'+
  #10+#13+'   2) Start HNS_REAL first. HNSKY will be started automatically.'+
  #10+#13+'   3) If not on, switch-on the DDE in HNSKY with cntrl-7.'+
  #10+#13+
  #10+#13+'This program can also be used to generate batch-wise FITS picture files by executing the program '+
          'with the following parameters:'+#10+#13+
  #10+#13+'  HNS_REAL.EXE  RA DEC [FILENAME WIDTH HEIGHT SUBSAMPLE]'+#10+#13+
  #10+#13+'If case the filename is specified, the program will create the FITS file and quit. '+
          'Normally 16 bit FITS file will be created but with the file extension ".FIT8" specified, additional 8 bit FITS will be created.'+
  #10+#13+
  #10+#13+
  #10+#13+'The GET_DSS.DLL is based on the REALSKY/DSS decoding work of Bill Gray of www.projectpluto.com '+
          'For non-commercial purpose only. See remarks at www.projectpluto.com'+
  #10+#13+
  #10+#13+'The Realsky or DSS CD'+char(39)+'s have to be purchased seperately.'+
  #10+#13+
  #10+#13+'The program can read 8 and 16 bit integer and 32 bit floating point FITS files. They can be saved as BMP or compact 8 bit integer FITS.'+
  #10+#13+
  #10+#13+'Send an e-mail if you like this free program. Feel free to distribute !'+
  #10+#13+
  #10+#13+'This is HNS_REAL, version 2.0.0c, dated 2015-8-11. by Han_k@hnsky.org. Webpage: www.hnsky.org'
 ,'About HNS_REAL, the Realsky telescope:',MB_OK);
end;

procedure Tmainwindow.AboutDSS1Click(Sender: TObject);
begin
  messagebox(mainwindow.handle,
   'The Digitized Sky Surveys were produced at the Space Telescope Science Institute under '+
   'U.S. Government grant NAG W-2166. The images of these surveys are based on photographic '+
   'data (POSS-I) obtained using the Oschin Schmidt Telescope on Palomar Mountain and the UK Schmidt '+
   'Telescope. The plates were processed into the present compressed digital form with the '+
   'permission of these institutions. '+
    #10+#13+
    #10+#13+
   'Digital Sky Survey 102 CD-Roms.'+
    #10+#13+
    #10+#13+
   'Real Sky South. 10 CD-Roms. (very high compression factor)'+
    #10+#13+
   'Real Sky North. 8  CD-Roms. (very high compression factor)'
  ,'About DSS',MB_OK);
end;

procedure Tmainwindow.AboutDDEcontrol1Click(Sender: TObject);
begin
 messagebox(mainwindow.handle,
  #10+#13+'Some Dynamic Data Exchange or DDE info for controlling HNS_REAL with an other application. '+
          'HNS_REAL can work both as a DDE server and client:'+
  #10+#13+
  #10+#13+
  #10+#13+'1) HNS_REAL as the DDE server. The other application as DDE client:'+
  #10+#13+
  #10+#13+'HNS_REAL is the DDE server "hns_real" with DDE topic "output" and two server items "target" and "mouse_pos". '+

          'The client can poke the Realsky target to "target". It should poke a string with RA and DEC in '+
          'hours and degrees seperated by a komma. String format: 24.000000,-90.000000 . '+
          'The HNS_REAL mouse position (RA/DEC) is available at "mouse_pos" (after left mouse button click). '+
          'See attached Excel example. '+
          'Remember that for floating numbers the decimal sign is a point and not a komma as in some countries. '+
  #10+#13+
  #10+#13+
  #10+#13+'2) HNSKY as the DDE server, HNS_REAL as the client:'+
  #10+#13+
  #10+#13+'HNSKY is the DDE server "hnsky" with DDE topic "output" and two server items '+
          '"target" and "telescope". "target" is used to provide the HNSKY RA/DEC position '+
          'to an other program such as HNS_REAL. It contains a string with RA and DEC in '+
          'radians seperated by a komma. Example: 3.141593,-1.570796. Size "1.6,+1.6" a total 18 '+
          'characters. '+
  #10+#13+'The HNS_REAL client is poking the mouse position back (after left mouse button click) '+
          'to item "telescope" '
  ,'About DDE',MB_OK);
end;

procedure Tmainwindow.Aboutplatesolution1Click(Sender: TObject);
begin
 messagebox(mainwindow.handle,
  #10+#13+'FITS file headers can contain either a WCS (World Coordinate System) or DSS proper astrometric plate solution. '+
          'This allows the software to convert the X,Y of your current cursor position to RA,DEC '+
  #10+#13+
  #10+#13+'The WCS solution is a linear solution, assuming the plate is linear. This is fine for small fields. '+
          'It is also easy to adjust. The WCS keywords are CRPIX1, 2,  CRVAL1, 2, CRDELT1,2 and CROTA2. '+
          'Instead of the CDELT1,2 and CROTA2 keywords, the new CD conversion matrix could been added. '+
          'Keywords are CD1_1, CD1_2, CD2_1 and CD2_2. This allows both scaling and rotation.'+
  #10+#13+
  #10+#13+'The FITS images that you pull with DSS could have such WCS keywords but also the full '+
          'non-linear Schmidt plate astrometric solution (the AMDX*,AMDY* words). '+
          'This will give the most accurate solution of the mouse pointer position. ',
  'About WCS and DSS plate solution:',MB_OK);
end;


Function strtofloat2(s : string):real;
var
  y    : real;
  error: integer;
begin
  {For Window version where floatings are written with a komma, the standard strtofloat does not accept 1.33 but only 1,33}
  {So this is an alternative routine with the good old Val procedure}
  val(s,y,error);
  if error<>0 then raise Exception.Create(s+' contains illegal character(s)!');
  strtofloat2:=y;
end;

Function  deg_and_minutes_tofloat(s:string):real;
var
  x: real;
  j: integer;
begin
   j:=pos(':',s);
   if j=0 then {12.50 format}
     x:=strtofloat2(s) {12.5 format}
   else {12:30.0 format}
   begin
     x:=(strtofloat2(copy(s,1,j-1)));
     if pos('-',s)>0 then x:=x - strtofloat2(copy(s,j+1,length(s)-j))/60
                     else x:=x + strtofloat2(copy(s,j+1,length(s)-j))/60 ;
   end;
   deg_and_minutes_tofloat:=x;
end;
procedure Tmainwindow.Button1Click(Sender: TObject);
var i : SImageConfig;
    rc : integer;
    dir,drv,ima : string;
begin
  application.title:='. . . . .'; {show working status}
  error_get_it.caption:='';
  dir:=trim(edit6.text);
    if pos('\',dir)=0 then dir:=currdir+'\'+dir;
    if dir[length(dir)]<>'\' then dir:=dir+'\';
  drv:=trim(edit7.text);
    if drv[length(drv)]<>'\' then drv:=drv+'\';
  ima:=trim(edit8.text);
  i.pDir:=Pchar(dir);
  i.pDrive:=Pchar(drv);
  i.pImageFile:=Pchar(ima);
  i.DataSource:=source_selection.itemindex+1;
  i.PromptForDisk:=prompt_cd.checked;{normally true, When compiling with Delphi 4, the disabling prompt_CD does not work. So use Delphi 6}
  i.SubSample:=strtoint(combobox1.text);

  i.ra:=deg_and_minutes_tofloat(edit1.text)*pi/12;{RA hours text 12:00.0  to radians float 3.14159}
  i.De:=deg_and_minutes_tofloat(edit2.text)*pi/180;{dec degrees text 90:00.0  to radians float 3.14159}

  i.Width:=strtofloat2(edit3.text);
  i.Height:=strtofloat2(edit4.text);

  i.Sender:=mainwindow.handle;
  i.pApplication:='HNS_REAL';
  i.pPrompt1:='Put RealSkyr CD nr.';
  i.pPrompt2:='in the drive';
  rc:=ImageExtract(addr(i));
  if rc<>0 then begin error_get_it.caption:='Error: '+inttostr(rc);error_get_it.font.color:=clred; end
           else begin error_get_it.caption:='';error_get_it.font.color:=clBtnFace;end;

  filename2:=edit8.Text;{for case background is changed}
  if pos('\',filename2)=0 then filename2:=currdir+filename2;
  if ((rc<>0) or (paramcount>2) or (showpicture.checked=false)) then {batch mode}
  begin {nothing}
  end
  else
  begin
  if sizechanged then
    begin
      left2:=realsky.left;{get old position}
      top2:=realsky.top;
      realsky.release;
     {create realsky form}
      realsky:=Trealsky.Create(self); {by purpose, in project option not loaded automatic}
     {special trick to get image1 during creation big enough. As soon it is created, size can not be adjusted. Then only option is the delete form and create it again}
      realsky.left:=left2;{use old position}
      realsky.top:=top2;
      sizechanged:=false;
    end;

    realsky.visible:=true;
    realsky.setfocus;

    if auto_adjust.checked=true then getfits_histogram(edit8.text);  {load and calculate histogram and adapt brightness and background settings}
    load_fits(edit8.text);
  end;
  application.title:='HNS_REAL';
end;

procedure Tmainwindow.DdeClientConv1Open(Sender: TObject);
begin
   mainwindow.labelserver.caption:='<->DDE server';
   mainwindow.labelserver.font.style:=[];
   mainwindow.labelserver.font.color:=CLgreen;
end;

procedure Tmainwindow.DdeClientConv1Close(Sender: TObject);
begin
   mainwindow.labelserver.caption:='<X>DDE server !';
   mainwindow.labelserver.font.color:=CLred;
end;
procedure loadsettings;
begin
  with settingstring do
  begin
    try
    LoadFromFile('HNS_REAL.CFG');	{ load from file }
    except
      mainwindow.combobox1.itemindex:=2;{for case no settings there}
      mainwindow.source_selection.itemindex:=3;{for case no settings there}
      exit;
    end;
  end;
  with mainwindow do
  begin
    if settingstring[0]<>'5.0' then exit;;
    edit1.text:=settingstring[1];
    edit2.text:=settingstring[2];
    edit3.text:=settingstring[3];
    edit4.text:=settingstring[4];
    combobox1.itemindex:=strtoint(settingstring[5]);
    edit6.text:=settingstring[6];
    edit7.text:=settingstring[7];
    edit8.text:=settingstring[8];
    source_selection.itemindex:=strtoint(settingstring[9]);

    mainwindow.left:=strtoint(settingstring[10]); {restore window positions}
    mainwindow.top:= strtoint(settingstring[11]);
    realsky.left:=strtoint(settingstring[12]);
    realsky.top:=strtoint(settingstring[13]);
    north_arrow.checked:=settingstring[14]='true';
    showpicture.checked:=settingstring[15]='true';
    dsspolynom.checked:=settingstring[16]='true';
    prompt_CD.checked:=settingstring[17]='true';
    try auto_adjust.checked:=settingstring[18]='true';except end;{temporary to prevent error old setting file}
    try use_datamin.checked:=settingstring[19]='true';except end;{temporary to prevent error old setting file}
  end;
end;
procedure Tmainwindow.Savesetting1Click(Sender: TObject);
begin
  settingstring.clear;  {tstrings}
  settingstring.add('5.0');
  settingstring.add(edit1.text);
  settingstring.add(edit2.text);
  settingstring.add(edit3.text);
  settingstring.add(edit4.text);
  settingstring.add(inttostr(combobox1.itemindex));
  settingstring.add(edit6.text);
  settingstring.add(edit7.text);
  settingstring.add(edit8.text);
  settingstring.add(inttostr(source_selection.itemindex));
  settingstring.add(inttostr(mainwindow.left));
  settingstring.add(inttostr(mainwindow.top));
  settingstring.add(inttostr(realsky.left));
  settingstring.add(inttostr(realsky.top));
  if north_arrow.checked then settingstring.add('true') else settingstring.add('false');
  if showpicture.checked then settingstring.add('true') else settingstring.add('false');
  if dsspolynom.checked then settingstring.add('true') else settingstring.add('false');
  if prompt_CD.checked then settingstring.add('true') else settingstring.add('false');
  if auto_adjust.checked then settingstring.add('true') else settingstring.add('false');
  if use_datamin.checked then settingstring.add('true') else settingstring.add('false');
  with settingstring do
  begin
    SaveToFile('HNS_REAL.CFG');{  save into file }
  end;
end;


procedure Tmainwindow.FormCreate(Sender: TObject);
var
   s,dllpath  : string;
   ret: integer;
begin
  {define external server}
  mainwindow.ddeclientconv1.SetLink('hnsky','output');
  mainwindow.ddeclientconv1.openlink;

  mainwindow.ddeclientitem1.ddeitem:='target';
  mainwindow.ddeclientitem2.ddeitem:='telescope';

  {create reasky form}
  realsky:=Trealsky.Create(self); {by purpose, in project option not loaded automatic}

  settingstring := Tstringlist.Create;
  loadsettings;
  currdir:=GetCurrentDir+'\';
   {load program parameters, overriding initial settings if any}
  with mainwindow do
  if paramstr(2)<>'' then {no file as parameter. Strange, alternative paramcount>1 give error "List index out of bound"}
  begin
    if paramstr(1)<>'' then edit1.text:= paramstr(1); {RA}
    if paramstr(2)<>'' then edit2.text:= paramstr(2); {DEC}
    if paramstr(3)<>'' then
    begin
      s:=paramstr(3); {filename}
      if s[length(s)]='8' then begin setlength(s,length(s)-1); makebit8:=true end else makebit8:=false;
      edit8.text:= s; {filename}
      mainwindow.windowstate:=wsminimized;{do not show window in batch mode}
    end;
    if paramstr(4)<>'' then edit3.text:= paramstr(4); {width}
    if paramstr(5)<>'' then edit4.text:= paramstr(5); {height}
    if paramstr(6)<>'' then
    begin
      if paramstr(6)='1' then combobox1.itemindex:=0; {subsample}
      if paramstr(6)='2' then combobox1.itemindex:=1; {subsample}
      if paramstr(6)='4' then combobox1.itemindex:=2; {subsample}
      if paramstr(6)='5' then combobox1.itemindex:=3; {subsample}
      if paramstr(6)='10' then combobox1.itemindex:=4; {subsample}
      if paramstr(6)='20' then combobox1.itemindex:=5; {subsample}
      if paramstr(6)='25' then combobox1.itemindex:=6; {subsample}
      if paramstr(6)='50' then combobox1.itemindex:=7; {subsample}
      if paramstr(6)='100' then combobox1.itemindex:=8;{rare subsample}
      if paramstr(6)='250' then combobox1.itemindex:=9;{rare subsample}
    end
  end;

  dsslib := LoadLibrary('getdss.dll');
  ret := GetLastError();
  if dsslib<>0 then begin
    ImageExtract:= TImageExtract(GetProcAddress(dsslib, 'ImageExtract'));
    GetPlateList:= TGetPlateList(GetProcAddress(dsslib, 'GetPlateList'));
    ImageExtractFromPlate:= TImageExtractFromPlate(GetProcAddress(dsslib, 'ImageExtractFromPlate'));
  end else begin
    showmessage('getdss.dll not loaded ! Error: '+inttostr(ret));
    close;
  end;

  if paramcount>2 then {batch mode}
  begin
    mainwindow.Button1Click(Sender);
    if makebit8 then
    begin
      savefits8(filename2,filename2+'8',false {do not use histogram});
    end;
    application.terminate;{quit program}
  end;
  application.HintHidePause:=5000;{display hint 5000 ms instead standard 2500}
  {application.HintPause:=1000;}
  application.HintShortPause:=1000;

end;

procedure Tmainwindow.FormDestroy(Sender: TObject);
begin
   freeLibrary(dsslib);
   ddeclientconv1.closelink;
   settingstring.free;
end;

procedure Tmainwindow.DdeClientItem1Change(Sender: TObject);
  {HNS_REAL client personality}

var
  komma,error:integer;
  RA,DEC     :real;
begin
  if (initialized=false) {wait one second during startup}
  then exit;

  komma:=pos(',',ddeclientitem1.text);
  if komma=0 then exit;
  val(copy(ddeclientitem1.text,1,komma-1),ra,error);
  if error<>0 then exit;
  mainwindow.edit1.text:=prepare_ra5(ra,':');

  val(copy(ddeclientitem1.text,komma+1,length(ddeclientitem1.text)-komma),dec,error);
  if error<>0 then exit;

  mainwindow.edit2.text:=prepare_dec5(dec,':');
  mainwindow.Button1Click(sender);{get it}
  {The length of the DDE string send by HNSKY is "1.6,+1.6" total 18, where the}
  {RA has a length of 8 and DEC 9 charactors.}
  {RA and DEC are separted by a komma. }
  {Example: 3.141593,-1.123456 or 3.141593, 1.123456}
end;


procedure Tmainwindow.Exit1Click(Sender: TObject);
begin
  application.terminate;
end;


procedure Tmainwindow.LoadFITSfile1Click(Sender: TObject);
begin
  OpenDialog1.Title := 'Open';
  OpenDialog1.Options := [ofFileMustExist,ofHideReadOnly];
  opendialog1.Filter := '8, 16, 32 and -32 bit FITS files (*.fit*)|*.FIT*';
  if opendialog1.execute then
  begin
    try
      left2:=realsky.left;{position}
      top2:=realsky.top;{position}
      realsky.release;
    except;
      {nothing}
    end;
    {create realsky form}
    realsky:=Trealsky.Create(self); {by purpose, in project option not loaded automatic}
    {special trick to get image1 during creation big enough. As soon it is created, size can not be adjusted. Then only option is the delete form and create it again}
    realsky.left:=left2;{position}
    realsky.top:=top2;{position}
    realsky.visible:=true;


    filename2:=opendialog1.filename;

    if auto_adjust.checked=true then getfits_histogram(filename2);  {load and calculate histogram and adapt brightness and background settings}
    load_fits(filename2);
  end;
end;
procedure FITS_BMP(filen:string);{save FITS to BMP file}
var filename3:string;
begin
  left2:=realsky.left;{position}
  top2:=realsky.top;{position}
  realsky.release;
   {create realsky form}
  realsky:=Trealsky.Create(mainwindow); {by purpose, in project option not loaded automatic}
  {special trick to get image1 during creation big enough. As soon it is created, size can not be adjusted. Then only option is the delete form and create it again}
  realsky.left:=left2;{position}
  realsky.top:=top2;{position}
  realsky.visible:=false;

  if mainwindow.auto_adjust.checked=true then getfits_histogram(filen);  {load and calculate histogram and adapt brightness and background settings}
  load_fits(filen);
  filename3:=ChangeFileExt(Filen,'.bmp');
  realsky.image1.picture.SaveToFile(filename3);
end;
procedure Tmainwindow.SaveasBMP1Click(Sender: TObject);{save image to bitmap file}
var filename3:string;
begin
  filename3:=ChangeFileExt(FileName2,'.bmp');
  savedialog1.filename:=filename3;
  savedialog1.Filter := 'BMP files (*.bmp)|*.bmp';
  if savedialog1.execute then
  begin
    realsky.image1.picture.SaveToFile(savedialog1.filename);
  end;
end;

procedure Tmainwindow.ShowFITSheader1Click(Sender: TObject);
var bericht: array[0..512] of char;{make this one not too short !}
begin
   strpcopy(bericht,
  'Origin: '+origin+#10+#13+
  'Telescope: '+ telescop+#10+#13+
  'Instrument: '+instrum+#10+#13+
  'Date-of-obs: '+date_obs+#10+#13+
  'Time-obs: '+Time_obs+#10+#13+
  'UT-time: '+UT+#10+#13+
  'Plt-label: '+Pltlabel+#10+#13+
  'Plate-id: '+plateid+#10+#13+
  'Bandpass: '+floattostr(bandpass)+#10+#13+
  'Equinox: '+floattostr(equinox)+#10+#13+
  'Exposure-time: '+floattostr(exposure));

  messagebox(mainwindow.handle,bericht,'FITS HEADER',MB_OK);
end;

procedure Tmainwindow.Edit3Change(Sender: TObject);
begin
  {edit3, 4  or 5 changed ,   {special trick to get realsky.image1 during creation big enough. As soon it is created, size can not be adjusted. Then only option is the delete form and create it again}
  sizechanged:=true;
end;

procedure Tmainwindow.targetPokeData(Sender: TObject);
var
  komma: integer;
begin
  {HNS_REAL server personality}
  begin
    if (initialized=false) {wait one second during startup}
    then exit;

    komma:=pos(',',target.text);

    edit1.text:=copy(target.text,1,komma-1);

    edit2.text:=copy(target.text,komma+1,length(target.text)-(komma));
    mainwindow.Button1Click(Sender);
  end;
end;

procedure Tmainwindow.FormPaint(Sender: TObject);
begin
   initialized:=true;
end;

procedure Tmainwindow.Saveas8bitFITS1Click(Sender: TObject);
begin
  repeat
    savedialog1.filename:=filename2+'8';
    savedialog1.Filter := '8 bit FITS files (*.fit8)|*.FIT8';
    if savedialog1.execute then
    begin
      if filename2<>savedialog1.filename then
          savefits8(filename2,savedialog1.filename,false);
    end;
  until filename2<>savedialog1.filename;
end;


procedure Tmainwindow.FormShow(Sender: TObject);
begin
  if paramcount=1 then   {file as first parameter}
  begin
    filename2:=paramstr(1);
    realsky.visible:=true;
    if auto_adjust.checked=true then getfits_histogram(filename2);  {load and calculate histogram and adapt brightness and background settings}
    load_fits(filename2);
  end;
end;

procedure Tmainwindow.Convertallfiles8bitFITS1_datamindatamaxClick(Sender: TObject);
var
  I: integer;
  Save_Cursor:TCursor;
begin
  OpenDialog1.Title := 'Select multiple  files to convert to 8 bit FITS';
  OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist,ofHideReadOnly];
  opendialog1.Filter := '16 and -32 bit FITS files (*.fit*)|*.FIT*';
  if OpenDialog1.Execute then
  begin
    Save_Cursor := Screen.Cursor;
    Screen.Cursor := crHourglass;    { Show hourglass cursor }
    try { Do some lengthy operation }
      with OpenDialog1.Files do
      for I := 0 to Count - 1 do
      begin
        savefits8(Strings[I],Strings[I]+'8',false {no range adaption to histogram});
      end;
    finally
      Screen.Cursor := Save_Cursor;  { Always restore to normal }
    end;
  end; {end conversion}
end;

procedure Tmainwindow.Convertallfiles8bitFITS1_usingsettingsClick(Sender: TObject);
var
  I: integer;
  Save_Cursor:TCursor;
begin
  OpenDialog1.Title := 'Select multiple  files to convert to 8 bit FITS';
  OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist,ofHideReadOnly];
  opendialog1.Filter := '16 and -32 bit FITS files (*.FIT;*.FITS)|*.FIT;*.FITS';
  if OpenDialog1.Execute then
  begin
    Save_Cursor := Screen.Cursor;
    Screen.Cursor := crHourglass;    { Show hourglass cursor }
    try { Do some lengthy operation }
      with OpenDialog1.Files do
      for I := 0 to Count - 1 do
      begin
        if OpenDialog1.Files.strings[I]<>'' then
        begin
        if auto_adjust.checked=true then
           getfits_histogram(OpenDialog1.Files.strings[I]);

        savefits8(Strings[I],Strings[I]+'8',auto_adjust.checked { range adaption to histogram});

        end;

      end;
    finally
      Screen.Cursor := Save_Cursor;  { Always restore to normal }
    end;
  end; {end conversion}
end;
procedure Tmainwindow.ConvertallFITStoBMP1Click(Sender: TObject);
var
  I: integer;
  Save_Cursor:TCursor;
begin
  OpenDialog1.Title := 'Select multiple  files to convert to 8 bit FITS';
  OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist,ofHideReadOnly];
  opendialog1.Filter := '8, 16 and -32 bit FITS files (*.fit*)|*.FIT*';
  if OpenDialog1.Execute then
  begin
    Save_Cursor := Screen.Cursor;
    Screen.Cursor := crHourglass;    { Show hourglass cursor }
    try { Do some lengthy operation }
        with OpenDialog1.Files do
        for I := 0 to Count - 1 do FITS_BMP(Strings[I]);
    finally
      Screen.Cursor := Save_Cursor;  { Always restore to normal }
    end;
//    realsky.release;  {release last window to clean up desktop}
  end;
end;

procedure Tmainwindow.Saveas8bitFITSfileadjustedClick(Sender: TObject);
begin
  repeat
    savedialog1.filename:=filename2+'8';
    savedialog1.Filter := '8 bit FITS files (*.fit8)|*.FIT8';
    if savedialog1.execute then
    begin
      if filename2<>savedialog1.filename then
           savefits8(filename2,savedialog1.filename,true);
    end;
  until filename2<>savedialog1.filename;
end;

procedure Tmainwindow.outputClose(Sender: TObject);
begin
   mainwindow.labelclient.caption:='<X>DDE client !';
   mainwindow.labelclient.font.color:=CLred;
end;

procedure Tmainwindow.outputOpen(Sender: TObject);
begin
   mainwindow.labelclient.caption:='<->DDE client';
   mainwindow.labelclient.font.style:=[];{normal}
   mainwindow.labelclient.font.color:=CLgreen;
end;

var
  I: integer;
  Save_Cursor:TCursor;


procedure Tmainwindow.backgroundScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  load_fits(filename2);
  invalidaterect(realsky.handle ,nil,false);{paint again}
end;

end.
